# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['DnsZone']


class DnsZone(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 contract: Optional[pulumi.Input[str]] = None,
                 end_customer_id: Optional[pulumi.Input[str]] = None,
                 group: Optional[pulumi.Input[str]] = None,
                 masters: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 sign_and_serve: Optional[pulumi.Input[bool]] = None,
                 sign_and_serve_algorithm: Optional[pulumi.Input[str]] = None,
                 target: Optional[pulumi.Input[str]] = None,
                 tsig_key: Optional[pulumi.Input[pulumi.InputType['DnsZoneTsigKeyArgs']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 zone: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        The `DnsZone` provides the resource for configuring a DNS zone to integrate easily with your existing DNS infrastructure to provide a secure, high performance, highly available and scalable solution for DNS hosting.

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        demozone = akamai.DnsZone("demozone",
            comment="some comment",
            contract="ctr_1-AB123",
            group="100",
            masters=[
                "1.2.3.4",
                "1.2.3.5",
            ],
            sign_and_serve=False,
            type="secondary",
            zone="example.com")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: A descriptive comment.
        :param pulumi.Input[str] contract: The contract ID.
        :param pulumi.Input[str] group: The currently selected group ID.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] masters: The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
        :param pulumi.Input[bool] sign_and_serve: Whether DNSSEC Sign&Serve is enabled.
        :param pulumi.Input[str] sign_and_serve_algorithm: Algorithm used by Sign&Serve.
        :param pulumi.Input[str] target: The name of the zone whose configuration this zone will copy.
        :param pulumi.Input[pulumi.InputType['DnsZoneTsigKeyArgs']] tsig_key: TSIG Key used in secure zone transfers
        :param pulumi.Input[str] type: Whether the zone is `primary` or `secondary`.
        :param pulumi.Input[str] zone: Domain zone, encapsulating any nested subdomains.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['comment'] = comment
            if contract is None and not opts.urn:
                raise TypeError("Missing required property 'contract'")
            __props__['contract'] = contract
            __props__['end_customer_id'] = end_customer_id
            if group is None and not opts.urn:
                raise TypeError("Missing required property 'group'")
            __props__['group'] = group
            __props__['masters'] = masters
            __props__['sign_and_serve'] = sign_and_serve
            __props__['sign_and_serve_algorithm'] = sign_and_serve_algorithm
            __props__['target'] = target
            __props__['tsig_key'] = tsig_key
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            if zone is None and not opts.urn:
                raise TypeError("Missing required property 'zone'")
            __props__['zone'] = zone
            __props__['activation_state'] = None
            __props__['alias_count'] = None
            __props__['version_id'] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="akamai:edgedns/dnsZone:DnsZone")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(DnsZone, __self__).__init__(
            'akamai:index/dnsZone:DnsZone',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            activation_state: Optional[pulumi.Input[str]] = None,
            alias_count: Optional[pulumi.Input[int]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            contract: Optional[pulumi.Input[str]] = None,
            end_customer_id: Optional[pulumi.Input[str]] = None,
            group: Optional[pulumi.Input[str]] = None,
            masters: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            sign_and_serve: Optional[pulumi.Input[bool]] = None,
            sign_and_serve_algorithm: Optional[pulumi.Input[str]] = None,
            target: Optional[pulumi.Input[str]] = None,
            tsig_key: Optional[pulumi.Input[pulumi.InputType['DnsZoneTsigKeyArgs']]] = None,
            type: Optional[pulumi.Input[str]] = None,
            version_id: Optional[pulumi.Input[str]] = None,
            zone: Optional[pulumi.Input[str]] = None) -> 'DnsZone':
        """
        Get an existing DnsZone resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: A descriptive comment.
        :param pulumi.Input[str] contract: The contract ID.
        :param pulumi.Input[str] group: The currently selected group ID.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] masters: The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
        :param pulumi.Input[bool] sign_and_serve: Whether DNSSEC Sign&Serve is enabled.
        :param pulumi.Input[str] sign_and_serve_algorithm: Algorithm used by Sign&Serve.
        :param pulumi.Input[str] target: The name of the zone whose configuration this zone will copy.
        :param pulumi.Input[pulumi.InputType['DnsZoneTsigKeyArgs']] tsig_key: TSIG Key used in secure zone transfers
        :param pulumi.Input[str] type: Whether the zone is `primary` or `secondary`.
        :param pulumi.Input[str] zone: Domain zone, encapsulating any nested subdomains.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["activation_state"] = activation_state
        __props__["alias_count"] = alias_count
        __props__["comment"] = comment
        __props__["contract"] = contract
        __props__["end_customer_id"] = end_customer_id
        __props__["group"] = group
        __props__["masters"] = masters
        __props__["sign_and_serve"] = sign_and_serve
        __props__["sign_and_serve_algorithm"] = sign_and_serve_algorithm
        __props__["target"] = target
        __props__["tsig_key"] = tsig_key
        __props__["type"] = type
        __props__["version_id"] = version_id
        __props__["zone"] = zone
        return DnsZone(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="activationState")
    def activation_state(self) -> pulumi.Output[str]:
        return pulumi.get(self, "activation_state")

    @property
    @pulumi.getter(name="aliasCount")
    def alias_count(self) -> pulumi.Output[int]:
        return pulumi.get(self, "alias_count")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        A descriptive comment.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def contract(self) -> pulumi.Output[str]:
        """
        The contract ID.
        """
        return pulumi.get(self, "contract")

    @property
    @pulumi.getter(name="endCustomerId")
    def end_customer_id(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "end_customer_id")

    @property
    @pulumi.getter
    def group(self) -> pulumi.Output[str]:
        """
        The currently selected group ID.
        """
        return pulumi.get(self, "group")

    @property
    @pulumi.getter
    def masters(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The names or addresses of the customer’s nameservers from which the zone data should be retrieved.
        """
        return pulumi.get(self, "masters")

    @property
    @pulumi.getter(name="signAndServe")
    def sign_and_serve(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether DNSSEC Sign&Serve is enabled.
        """
        return pulumi.get(self, "sign_and_serve")

    @property
    @pulumi.getter(name="signAndServeAlgorithm")
    def sign_and_serve_algorithm(self) -> pulumi.Output[Optional[str]]:
        """
        Algorithm used by Sign&Serve.
        """
        return pulumi.get(self, "sign_and_serve_algorithm")

    @property
    @pulumi.getter
    def target(self) -> pulumi.Output[Optional[str]]:
        """
        The name of the zone whose configuration this zone will copy.
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter(name="tsigKey")
    def tsig_key(self) -> pulumi.Output[Optional['outputs.DnsZoneTsigKey']]:
        """
        TSIG Key used in secure zone transfers
        """
        return pulumi.get(self, "tsig_key")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Whether the zone is `primary` or `secondary`.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="versionId")
    def version_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "version_id")

    @property
    @pulumi.getter
    def zone(self) -> pulumi.Output[str]:
        """
        Domain zone, encapsulating any nested subdomains.
        """
        return pulumi.get(self, "zone")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

