# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = [
    'GetAppSecCustomRulesResult',
    'AwaitableGetAppSecCustomRulesResult',
    'get_app_sec_custom_rules',
]

@pulumi.output_type
class GetAppSecCustomRulesResult:
    """
    A collection of values returned by getAppSecCustomRules.
    """
    def __init__(__self__, config_id=None, id=None, output_text=None):
        if config_id and not isinstance(config_id, int):
            raise TypeError("Expected argument 'config_id' to be a int")
        pulumi.set(__self__, "config_id", config_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> int:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        """
        A tabular display showing the ID and name of the custom rules defined for the security configuration.
        """
        return pulumi.get(self, "output_text")


class AwaitableGetAppSecCustomRulesResult(GetAppSecCustomRulesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecCustomRulesResult(
            config_id=self.config_id,
            id=self.id,
            output_text=self.output_text)


def get_app_sec_custom_rules(config_id: Optional[int] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecCustomRulesResult:
    """
    Use the `getAppSecCustomRules` data source to retrieve a list of the custom rules defined for a security configuration.

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    configuration = akamai.get_app_sec_configuration(name="Akamai Tools")
    custom_rules = akamai.get_app_sec_custom_rules(config_id=configuration.config_id)
    pulumi.export("customRulesList", custom_rules.output_text)
    ```


    :param int config_id: The ID of the security configuration to use.
    """
    __args__ = dict()
    __args__['configId'] = config_id
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecCustomRules:getAppSecCustomRules', __args__, opts=opts, typ=GetAppSecCustomRulesResult).value

    return AwaitableGetAppSecCustomRulesResult(
        config_id=__ret__.config_id,
        id=__ret__.id,
        output_text=__ret__.output_text)
