# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['GtmResource']


class GtmResource(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aggregation_type: Optional[pulumi.Input[str]] = None,
                 constrained_property: Optional[pulumi.Input[str]] = None,
                 decay_rate: Optional[pulumi.Input[float]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 host_header: Optional[pulumi.Input[str]] = None,
                 leader_string: Optional[pulumi.Input[str]] = None,
                 least_squares_decay: Optional[pulumi.Input[float]] = None,
                 load_imbalance_percentage: Optional[pulumi.Input[float]] = None,
                 max_u_multiplicative_increment: Optional[pulumi.Input[float]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 resource_instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GtmResourceResourceInstanceArgs']]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 upper_bound: Optional[pulumi.Input[int]] = None,
                 wait_on_complete: Optional[pulumi.Input[bool]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        `GtmResource` provides the resource for creating, configuring and importing a gtm resource to integrate easily with your existing GTM infrastructure to provide a secure, high performance, highly available and scalable solution for Global Traffic Management. Note: Import requires an ID of the format: `existing_domain_name`:`existing_resource_name`

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        demo_resource = akamai.GtmResource("demoResource",
            aggregation_type="latest",
            domain="demo_domain.akadns.net",
            type="XML load object via HTTP")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Domain name
        :param pulumi.Input[str] name: Resource name
               * `aggregation_type`
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GtmResourceResourceInstanceArgs']]]] resource_instances: * `datacenter_id`
               * `load_object`
               * `load_object_port`
        :param pulumi.Input[str] type: Resource type
        :param pulumi.Input[bool] wait_on_complete: Wait for transaction to complete
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if aggregation_type is None and not opts.urn:
                raise TypeError("Missing required property 'aggregation_type'")
            __props__['aggregation_type'] = aggregation_type
            __props__['constrained_property'] = constrained_property
            __props__['decay_rate'] = decay_rate
            __props__['description'] = description
            if domain is None and not opts.urn:
                raise TypeError("Missing required property 'domain'")
            __props__['domain'] = domain
            __props__['host_header'] = host_header
            __props__['leader_string'] = leader_string
            __props__['least_squares_decay'] = least_squares_decay
            __props__['load_imbalance_percentage'] = load_imbalance_percentage
            __props__['max_u_multiplicative_increment'] = max_u_multiplicative_increment
            __props__['name'] = name
            __props__['resource_instances'] = resource_instances
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['upper_bound'] = upper_bound
            __props__['wait_on_complete'] = wait_on_complete
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="akamai:trafficmanagement/gtmResource:GtmResource")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(GtmResource, __self__).__init__(
            'akamai:index/gtmResource:GtmResource',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            aggregation_type: Optional[pulumi.Input[str]] = None,
            constrained_property: Optional[pulumi.Input[str]] = None,
            decay_rate: Optional[pulumi.Input[float]] = None,
            description: Optional[pulumi.Input[str]] = None,
            domain: Optional[pulumi.Input[str]] = None,
            host_header: Optional[pulumi.Input[str]] = None,
            leader_string: Optional[pulumi.Input[str]] = None,
            least_squares_decay: Optional[pulumi.Input[float]] = None,
            load_imbalance_percentage: Optional[pulumi.Input[float]] = None,
            max_u_multiplicative_increment: Optional[pulumi.Input[float]] = None,
            name: Optional[pulumi.Input[str]] = None,
            resource_instances: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GtmResourceResourceInstanceArgs']]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            upper_bound: Optional[pulumi.Input[int]] = None,
            wait_on_complete: Optional[pulumi.Input[bool]] = None) -> 'GtmResource':
        """
        Get an existing GtmResource resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Domain name
        :param pulumi.Input[str] name: Resource name
               * `aggregation_type`
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['GtmResourceResourceInstanceArgs']]]] resource_instances: * `datacenter_id`
               * `load_object`
               * `load_object_port`
        :param pulumi.Input[str] type: Resource type
        :param pulumi.Input[bool] wait_on_complete: Wait for transaction to complete
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["aggregation_type"] = aggregation_type
        __props__["constrained_property"] = constrained_property
        __props__["decay_rate"] = decay_rate
        __props__["description"] = description
        __props__["domain"] = domain
        __props__["host_header"] = host_header
        __props__["leader_string"] = leader_string
        __props__["least_squares_decay"] = least_squares_decay
        __props__["load_imbalance_percentage"] = load_imbalance_percentage
        __props__["max_u_multiplicative_increment"] = max_u_multiplicative_increment
        __props__["name"] = name
        __props__["resource_instances"] = resource_instances
        __props__["type"] = type
        __props__["upper_bound"] = upper_bound
        __props__["wait_on_complete"] = wait_on_complete
        return GtmResource(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="aggregationType")
    def aggregation_type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "aggregation_type")

    @property
    @pulumi.getter(name="constrainedProperty")
    def constrained_property(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "constrained_property")

    @property
    @pulumi.getter(name="decayRate")
    def decay_rate(self) -> pulumi.Output[Optional[float]]:
        return pulumi.get(self, "decay_rate")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[str]:
        """
        Domain name
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter(name="hostHeader")
    def host_header(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "host_header")

    @property
    @pulumi.getter(name="leaderString")
    def leader_string(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "leader_string")

    @property
    @pulumi.getter(name="leastSquaresDecay")
    def least_squares_decay(self) -> pulumi.Output[Optional[float]]:
        return pulumi.get(self, "least_squares_decay")

    @property
    @pulumi.getter(name="loadImbalancePercentage")
    def load_imbalance_percentage(self) -> pulumi.Output[Optional[float]]:
        return pulumi.get(self, "load_imbalance_percentage")

    @property
    @pulumi.getter(name="maxUMultiplicativeIncrement")
    def max_u_multiplicative_increment(self) -> pulumi.Output[Optional[float]]:
        return pulumi.get(self, "max_u_multiplicative_increment")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Resource name
        * `aggregation_type`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="resourceInstances")
    def resource_instances(self) -> pulumi.Output[Optional[Sequence['outputs.GtmResourceResourceInstance']]]:
        """
        * `datacenter_id`
        * `load_object`
        * `load_object_port`
        """
        return pulumi.get(self, "resource_instances")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Resource type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="upperBound")
    def upper_bound(self) -> pulumi.Output[Optional[int]]:
        return pulumi.get(self, "upper_bound")

    @property
    @pulumi.getter(name="waitOnComplete")
    def wait_on_complete(self) -> pulumi.Output[Optional[bool]]:
        """
        Wait for transaction to complete
        """
        return pulumi.get(self, "wait_on_complete")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

